﻿using System;
using System.Timers;
using Ozeki.Media.MediaHandlers;

namespace DTMF_IVR_WinForm.Model
{
    class IVRMenuTransfer :IVRMenuBase
    {

        private WaveStreamPlayback waveStreamPlayback;
        private Timer timerdial;

        private string dialNumber;

   
        public IVRMenuTransfer(IVRMenuElement menu):base(menu)
        {}

        public override void StartIntroduction()
        {
            timerdial=new Timer(20000);
            timerdial.AutoReset = false;
            timerdial.Elapsed += new ElapsedEventHandler(timerdial_Elapsed);
            waveStreamPlayback = new WaveStreamPlayback(Introduction);
            waveStreamPlayback.Stopped += new EventHandler<EventArgs>(waveStreamPlayback_Stopped);
            OnIntroductionStarting(waveStreamPlayback);
            waveStreamPlayback.StartStreaming();   
        }

        public override void StopIntroduction()
        {
            waveStreamPlayback.Stopped -= waveStreamPlayback_Stopped;
            waveStreamPlayback.StopStreaming();
            OnIntroductionStoped(waveStreamPlayback);
            waveStreamPlayback.Dispose();
            timerdial.Stop();
            timerdial.Elapsed -= timerdial_Elapsed;
            timerdial.Dispose();
        }

        public override void RestartIntroduction()
        {
            waveStreamPlayback.StartStreaming();
        }

        public override void CommandReceived(int signal)
        {
            waveStreamPlayback.Stopped -= waveStreamPlayback_Stopped;
            waveStreamPlayback.StopStreaming();
            switch (signal)
            {
                case 0:
                    CloseWaveStreamPlayback();
                    OnStepIntoMenu(null);
                    return;
                case 10:
                    CloseWaveStreamPlayback();
                    OnStepIntoMenu(Parent);
                    return;
                case 11:
                    CloseWaveStreamPlayback();

                    //Todo transfer
                    return;   
                    
            }
            dialNumber += signal.ToString();

        }

        void waveStreamPlayback_Stopped(object sender, EventArgs e)
        {
           timerdial.Start();
        }


        void CloseWaveStreamPlayback()
        {
            waveStreamPlayback.Stopped -= waveStreamPlayback_Stopped;
            waveStreamPlayback.StopStreaming();
            OnIntroductionStoped(waveStreamPlayback);
            waveStreamPlayback.Dispose();   
        }

        void timerdial_Elapsed(object sender, ElapsedEventArgs e)
        {
            dialNumber = String.Empty;
            RestartIntroduction();
        }
    }
}
